*** a/src/backend/optimizer/plan/planagg.c
--- b/src/backend/optimizer/plan/planagg.c
***************
*** 28,33 ****
--- 28,34 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_aggregate.h"
  #include "catalog/pg_type.h"
  #include "nodes/makefuncs.h"
*** a/src/backend/optimizer/plan/planner.c
--- b/src/backend/optimizer/plan/planner.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include <limits.h>
  
+ #include "access/htup.h"
  #include "executor/executor.h"
  #include "executor/nodeAgg.h"
  #include "miscadmin.h"
*** a/src/backend/optimizer/plan/subselect.c
--- b/src/backend/optimizer/plan/subselect.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_type.h"
  #include "executor/executor.h"
*** a/src/backend/optimizer/prep/prepunion.c
--- b/src/backend/optimizer/prep/prepunion.c
***************
*** 28,35 ****
--- 28,37 ----
   */
  #include "postgres.h"
  
+ #include <limits.h>
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/pg_inherits_fn.h"
  #include "catalog/pg_type.h"
*** a/src/backend/optimizer/util/clauses.c
--- b/src/backend/optimizer/util/clauses.c
***************
*** 19,24 ****
--- 19,25 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_aggregate.h"
  #include "catalog/pg_language.h"
  #include "catalog/pg_operator.h"
*** a/src/backend/optimizer/util/plancat.c
--- b/src/backend/optimizer/util/plancat.c
***************
*** 19,26 ****
--- 19,28 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/transam.h"
+ #include "access/xlog.h"
  #include "catalog/catalog.h"
  #include "catalog/heap.h"
  #include "miscadmin.h"
*** a/src/backend/parser/parse_coerce.c
--- b/src/backend/parser/parse_coerce.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_cast.h"
  #include "catalog/pg_class.h"
  #include "catalog/pg_inherits_fn.h"
*** a/src/backend/parser/parse_func.c
--- b/src/backend/parser/parse_func.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
*** a/src/backend/parser/parse_node.c
--- b/src/backend/parser/parse_node.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "mb/pg_wchar.h"
  #include "nodes/makefuncs.h"
*** a/src/backend/parser/parse_oper.c
--- b/src/backend/parser/parse_oper.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_type.h"
  #include "lib/stringinfo.h"
*** a/src/backend/parser/parse_relation.c
--- b/src/backend/parser/parse_relation.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/heap.h"
  #include "catalog/namespace.h"
*** a/src/backend/parser/parse_type.c
--- b/src/backend/parser/parse_type.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
  #include "lib/stringinfo.h"
*** a/src/backend/parser/parse_utilcmd.c
--- b/src/backend/parser/parse_utilcmd.c
***************
*** 26,31 ****
--- 26,32 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "catalog/dependency.h"
  #include "catalog/heap.h"
*** a/src/backend/postmaster/autovacuum.c
--- b/src/backend/postmaster/autovacuum.c
***************
*** 68,73 ****
--- 68,74 ----
  #include <unistd.h>
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/transam.h"
  #include "access/xact.h"
***************
*** 76,81 ****
--- 77,83 ----
  #include "catalog/pg_database.h"
  #include "commands/dbcommands.h"
  #include "commands/vacuum.h"
+ #include "lib/dllist.h"
  #include "libpq/pqsignal.h"
  #include "miscadmin.h"
  #include "pgstat.h"
*** a/src/backend/postmaster/bgwriter.c
--- b/src/backend/postmaster/bgwriter.c
***************
*** 46,51 ****
--- 46,52 ----
  #include "postmaster/bgwriter.h"
  #include "storage/bufmgr.h"
  #include "storage/buf_internals.h"
+ #include "storage/fd.h"
  #include "storage/ipc.h"
  #include "storage/lwlock.h"
  #include "storage/proc.h"
*** a/src/backend/postmaster/checkpointer.c
--- b/src/backend/postmaster/checkpointer.c
***************
*** 48,53 ****
--- 48,54 ----
  #include "postmaster/bgwriter.h"
  #include "replication/syncrep.h"
  #include "storage/bufmgr.h"
+ #include "storage/fd.h"
  #include "storage/ipc.h"
  #include "storage/lwlock.h"
  #include "storage/proc.h"
*** a/src/backend/postmaster/pgstat.c
--- b/src/backend/postmaster/pgstat.c
***************
*** 32,37 ****
--- 32,38 ----
  #include "pgstat.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/transam.h"
  #include "access/twophase_rmgr.h"
  #include "access/xact.h"
*** a/src/backend/postmaster/walwriter.c
--- b/src/backend/postmaster/walwriter.c
***************
*** 51,56 ****
--- 51,57 ----
  #include "miscadmin.h"
  #include "postmaster/walwriter.h"
  #include "storage/bufmgr.h"
+ #include "storage/fd.h"
  #include "storage/ipc.h"
  #include "storage/lwlock.h"
  #include "storage/proc.h"
*** a/src/backend/rewrite/rewriteDefine.c
--- b/src/backend/rewrite/rewriteDefine.c
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/rewrite/rewriteRemove.c
--- b/src/backend/rewrite/rewriteRemove.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/rewrite/rewriteSupport.c
--- b/src/backend/rewrite/rewriteSupport.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/heapam.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_rewrite.h"
*** a/src/backend/storage/buffer/bufmgr.c
--- b/src/backend/storage/buffer/bufmgr.c
***************
*** 46,52 ****
  #include "storage/smgr.h"
  #include "storage/standby.h"
  #include "utils/rel.h"
! #include "utils/resowner.h"
  #include "utils/timestamp.h"
  
  
--- 46,52 ----
  #include "storage/smgr.h"
  #include "storage/standby.h"
  #include "utils/rel.h"
! #include "utils/resowner_private.h"
  #include "utils/timestamp.h"
  
  
*** a/src/backend/storage/buffer/localbuf.c
--- b/src/backend/storage/buffer/localbuf.c
***************
*** 21,27 ****
  #include "storage/bufmgr.h"
  #include "utils/guc.h"
  #include "utils/memutils.h"
! #include "utils/resowner.h"
  
  
  /*#define LBDEBUG*/
--- 21,27 ----
  #include "storage/bufmgr.h"
  #include "utils/guc.h"
  #include "utils/memutils.h"
! #include "utils/resowner_private.h"
  
  
  /*#define LBDEBUG*/
*** a/src/backend/storage/file/fd.c
--- b/src/backend/storage/file/fd.c
***************
*** 57,63 ****
  #include "storage/fd.h"
  #include "storage/ipc.h"
  #include "utils/guc.h"
! #include "utils/resowner.h"
  
  
  /*
--- 57,63 ----
  #include "storage/fd.h"
  #include "storage/ipc.h"
  #include "utils/guc.h"
! #include "utils/resowner_private.h"
  
  
  /*
*** a/src/backend/storage/ipc/procsignal.c
--- b/src/backend/storage/ipc/procsignal.c
***************
*** 21,26 ****
--- 21,27 ----
  #include "miscadmin.h"
  #include "storage/latch.h"
  #include "storage/ipc.h"
+ #include "storage/shmem.h"
  #include "storage/sinval.h"
  #include "tcop/tcopprot.h"
  
*** a/src/backend/storage/lmgr/lock.c
--- b/src/backend/storage/lmgr/lock.c
***************
*** 44,50 ****
  #include "storage/standby.h"
  #include "utils/memutils.h"
  #include "utils/ps_status.h"
! #include "utils/resowner.h"
  
  
  /* This configuration variable is used to set the lock table size */
--- 44,50 ----
  #include "storage/standby.h"
  #include "utils/memutils.h"
  #include "utils/ps_status.h"
! #include "utils/resowner_private.h"
  
  
  /* This configuration variable is used to set the lock table size */
*** a/src/backend/storage/lmgr/predicate.c
--- b/src/backend/storage/lmgr/predicate.c
***************
*** 183,188 ****
--- 183,189 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/slru.h"
  #include "access/subtrans.h"
  #include "access/transam.h"
*** a/src/backend/tcop/fastpath.c
--- b/src/backend/tcop/fastpath.c
***************
*** 20,25 ****
--- 20,26 ----
  #include <netinet/in.h>
  #include <arpa/inet.h>
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/pg_proc.h"
  #include "libpq/libpq.h"
*** a/src/backend/tcop/utility.c
--- b/src/backend/tcop/utility.c
***************
*** 16,21 ****
--- 16,22 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/twophase.h"
  #include "access/xact.h"
*** a/src/backend/tsearch/ts_selfuncs.c
--- b/src/backend/tsearch/ts_selfuncs.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_type.h"
  #include "miscadmin.h"
*** a/src/backend/tsearch/wparser.c
--- b/src/backend/tsearch/wparser.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "funcapi.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
*** a/src/backend/utils/adt/acl.c
--- b/src/backend/utils/adt/acl.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_authid.h"
  #include "catalog/pg_auth_members.h"
***************
*** 29,34 ****
--- 30,36 ----
  #include "miscadmin.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
  #include "utils/memutils.h"
*** a/src/backend/utils/adt/array_selfuncs.c
--- b/src/backend/utils/adt/array_selfuncs.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <math.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_collation.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_statistic.h"
*** a/src/backend/utils/adt/arrayfuncs.c
--- b/src/backend/utils/adt/arrayfuncs.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "funcapi.h"
  #include "libpq/pqformat.h"
  #include "utils/array.h"
*** a/src/backend/utils/adt/datetime.c
--- b/src/backend/utils/adt/datetime.c
***************
*** 19,24 ****
--- 19,26 ----
  #include <limits.h>
  #include <math.h>
  
+ #include "access/htup.h"
+ #include "access/heapam.h"
  #include "access/xact.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
*** a/src/backend/utils/adt/dbsize.c
--- b/src/backend/utils/adt/dbsize.c
***************
*** 15,20 ****
--- 15,21 ----
  #include <sys/stat.h>
  
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/catalog.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_tablespace.h"
*** a/src/backend/utils/adt/enum.c
--- b/src/backend/utils/adt/enum.c
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_enum.h"
  #include "libpq/pqformat.h"
*** a/src/backend/utils/adt/format_type.c
--- b/src/backend/utils/adt/format_type.c
***************
*** 17,22 ****
--- 17,23 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
  #include "utils/builtins.h"
*** a/src/backend/utils/adt/genfile.c
--- b/src/backend/utils/adt/genfile.c
***************
*** 20,25 ****
--- 20,26 ----
  #include <unistd.h>
  #include <dirent.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "mb/pg_wchar.h"
*** a/src/backend/utils/adt/json.c
--- b/src/backend/utils/adt/json.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "executor/spi.h"
  #include "lib/stringinfo.h"
*** a/src/backend/utils/adt/lockfuncs.c
--- b/src/backend/utils/adt/lockfuncs.c
***************
*** 12,17 ****
--- 12,18 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "miscadmin.h"
*** a/src/backend/utils/adt/pg_locale.c
--- b/src/backend/utils/adt/pg_locale.c
***************
*** 54,59 ****
--- 54,60 ----
  #include <locale.h>
  #include <time.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_collation.h"
  #include "catalog/pg_control.h"
  #include "mb/pg_wchar.h"
*** a/src/backend/utils/adt/pgstatfuncs.c
--- b/src/backend/utils/adt/pgstatfuncs.c
***************
*** 14,19 ****
--- 14,20 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "funcapi.h"
  #include "libpq/ip.h"
*** a/src/backend/utils/adt/rangetypes_selfuncs.c
--- b/src/backend/utils/adt/rangetypes_selfuncs.c
***************
*** 17,22 ****
--- 17,23 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_statistic.h"
  #include "utils/lsyscache.h"
*** a/src/backend/utils/adt/regproc.c
--- b/src/backend/utils/adt/regproc.c
***************
*** 23,28 ****
--- 23,29 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_class.h"
*** a/src/backend/utils/adt/ri_triggers.c
--- b/src/backend/utils/adt/ri_triggers.c
***************
*** 30,35 ****
--- 30,36 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "access/sysattr.h"
  #include "catalog/pg_collation.h"
*** a/src/backend/utils/adt/rowtypes.c
--- b/src/backend/utils/adt/rowtypes.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <ctype.h>
  
+ #include "access/htup.h"
  #include "catalog/pg_type.h"
  #include "libpq/pqformat.h"
  #include "utils/builtins.h"
*** a/src/backend/utils/adt/ruleutils.c
--- b/src/backend/utils/adt/ruleutils.c
***************
*** 18,23 ****
--- 18,24 ----
  #include <unistd.h>
  #include <fcntl.h>
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/dependency.h"
  #include "catalog/indexing.h"
*** a/src/backend/utils/adt/selfuncs.c
--- b/src/backend/utils/adt/selfuncs.c
***************
*** 101,106 ****
--- 101,107 ----
  #include <math.h>
  
  #include "access/gin.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/index.h"
  #include "catalog/pg_collation.h"
*** a/src/backend/utils/adt/trigfuncs.c
--- b/src/backend/utils/adt/trigfuncs.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "commands/trigger.h"
  #include "utils/builtins.h"
  #include "utils/rel.h"
*** a/src/backend/utils/adt/xml.c
--- b/src/backend/utils/adt/xml.c
***************
*** 67,72 ****
--- 67,73 ----
  #endif
  #endif   /* USE_LIBXML */
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
  #include "commands/dbcommands.h"
*** a/src/backend/utils/cache/attoptcache.c
--- b/src/backend/utils/cache/attoptcache.c
***************
*** 18,23 ****
--- 18,24 ----
  
  #include "access/reloptions.h"
  #include "utils/attoptcache.h"
+ #include "utils/catcache.h"
  #include "utils/hsearch.h"
  #include "utils/inval.h"
  #include "utils/syscache.h"
*** a/src/backend/utils/cache/catcache.c
--- b/src/backend/utils/cache/catcache.c
***************
*** 33,39 ****
  #include "utils/inval.h"
  #include "utils/memutils.h"
  #include "utils/rel.h"
! #include "utils/resowner.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  
--- 33,39 ----
  #include "utils/inval.h"
  #include "utils/memutils.h"
  #include "utils/rel.h"
! #include "utils/resowner_private.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  
*** a/src/backend/utils/cache/evtcache.c
--- b/src/backend/utils/cache/evtcache.c
***************
*** 15,26 ****
--- 15,28 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "catalog/pg_event_trigger.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
  #include "utils/array.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/evtcache.h"
  #include "utils/inval.h"
  #include "utils/memutils.h"
*** a/src/backend/utils/cache/inval.c
--- b/src/backend/utils/cache/inval.c
***************
*** 95,105 ****
--- 95,107 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "miscadmin.h"
  #include "storage/sinval.h"
  #include "storage/smgr.h"
+ #include "utils/catcache.h"
  #include "utils/inval.h"
  #include "utils/memutils.h"
  #include "utils/rel.h"
*** a/src/backend/utils/cache/lsyscache.c
--- b/src/backend/utils/cache/lsyscache.c
***************
*** 16,21 ****
--- 16,22 ----
  #include "postgres.h"
  
  #include "access/hash.h"
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "bootstrap/bootstrap.h"
  #include "catalog/pg_amop.h"
***************
*** 33,38 ****
--- 34,40 ----
  #include "nodes/makefuncs.h"
  #include "utils/array.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/datum.h"
  #include "utils/fmgroids.h"
  #include "utils/lsyscache.h"
*** a/src/backend/utils/cache/plancache.c
--- b/src/backend/utils/cache/plancache.c
***************
*** 61,66 ****
--- 61,67 ----
  #include "tcop/utility.h"
  #include "utils/inval.h"
  #include "utils/memutils.h"
+ #include "utils/resowner_private.h"
  #include "utils/snapmgr.h"
  #include "utils/syscache.h"
  
*** a/src/backend/utils/cache/relcache.c
--- b/src/backend/utils/cache/relcache.c
***************
*** 30,35 ****
--- 30,36 ----
  #include <fcntl.h>
  #include <unistd.h>
  
+ #include "access/htup.h"
  #include "access/reloptions.h"
  #include "access/sysattr.h"
  #include "access/transam.h"
***************
*** 69,75 ****
  #include "utils/lsyscache.h"
  #include "utils/memutils.h"
  #include "utils/relmapper.h"
! #include "utils/resowner.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  
--- 70,76 ----
  #include "utils/lsyscache.h"
  #include "utils/memutils.h"
  #include "utils/relmapper.h"
! #include "utils/resowner_private.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
  
*** a/src/backend/utils/cache/spccache.c
--- b/src/backend/utils/cache/spccache.c
***************
*** 23,28 ****
--- 23,29 ----
  #include "commands/tablespace.h"
  #include "miscadmin.h"
  #include "optimizer/cost.h"
+ #include "utils/catcache.h"
  #include "utils/hsearch.h"
  #include "utils/inval.h"
  #include "utils/spccache.h"
*** a/src/backend/utils/cache/syscache.c
--- b/src/backend/utils/cache/syscache.c
***************
*** 20,25 ****
--- 20,26 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_aggregate.h"
***************
*** 56,61 ****
--- 57,63 ----
  #include "catalog/pg_type.h"
  #include "catalog/pg_user_mapping.h"
  #include "utils/rel.h"
+ #include "utils/catcache.h"
  #include "utils/syscache.h"
  
  
*** a/src/backend/utils/cache/ts_cache.c
--- b/src/backend/utils/cache/ts_cache.c
***************
*** 28,33 ****
--- 28,34 ----
  
  #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/xact.h"
  #include "catalog/indexing.h"
  #include "catalog/namespace.h"
***************
*** 39,44 ****
--- 40,46 ----
  #include "commands/defrem.h"
  #include "tsearch/ts_cache.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/fmgroids.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
*** a/src/backend/utils/cache/typcache.c
--- b/src/backend/utils/cache/typcache.c
***************
*** 47,52 ****
--- 47,53 ----
  
  #include "access/hash.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_enum.h"
***************
*** 55,60 ****
--- 56,62 ----
  #include "catalog/pg_type.h"
  #include "commands/defrem.h"
  #include "utils/builtins.h"
+ #include "utils/catcache.h"
  #include "utils/fmgroids.h"
  #include "utils/inval.h"
  #include "utils/lsyscache.h"
*** a/src/backend/utils/fmgr/funcapi.c
--- b/src/backend/utils/fmgr/funcapi.c
***************
*** 13,18 ****
--- 13,19 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
*** a/src/backend/utils/init/miscinit.c
--- b/src/backend/utils/init/miscinit.c
***************
*** 29,34 ****
--- 29,35 ----
  #include <utime.h>
  #endif
  
+ #include "access/htup.h"
  #include "catalog/pg_authid.h"
  #include "mb/pg_wchar.h"
  #include "miscadmin.h"
*** a/src/backend/utils/init/postinit.c
--- b/src/backend/utils/init/postinit.c
***************
*** 19,25 ****
--- 19,27 ----
  #include <fcntl.h>
  #include <unistd.h>
  
+ #include "access/genam.h"
  #include "access/heapam.h"
+ #include "access/htup.h"
  #include "access/sysattr.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
*** a/src/backend/utils/misc/superuser.c
--- b/src/backend/utils/misc/superuser.c
***************
*** 20,25 ****
--- 20,26 ----
   */
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "catalog/pg_authid.h"
  #include "utils/inval.h"
  #include "utils/syscache.h"
*** a/src/backend/utils/mmgr/portalmem.c
--- b/src/backend/utils/mmgr/portalmem.c
***************
*** 22,28 ****
--- 22,30 ----
  #include "catalog/pg_type.h"
  #include "commands/portalcmds.h"
  #include "miscadmin.h"
+ #include "nodes/execnodes.h"
  #include "utils/builtins.h"
+ #include "utils/hsearch.h"
  #include "utils/memutils.h"
  #include "utils/timestamp.h"
  
*** a/src/backend/utils/resowner/resowner.c
--- b/src/backend/utils/resowner/resowner.c
***************
*** 25,30 ****
--- 25,31 ----
  #include "storage/proc.h"
  #include "utils/memutils.h"
  #include "utils/rel.h"
+ #include "utils/resowner_private.h"
  #include "utils/snapmgr.h"
  
  /*
*** a/src/backend/utils/sort/tuplesort.c
--- b/src/backend/utils/sort/tuplesort.c
***************
*** 100,105 ****
--- 100,106 ----
  
  #include <limits.h>
  
+ #include "access/htup.h"
  #include "access/nbtree.h"
  #include "catalog/index.h"
  #include "commands/tablespace.h"
*** a/src/backend/utils/sort/tuplestore.c
--- b/src/backend/utils/sort/tuplestore.c
***************
*** 54,59 ****
--- 54,60 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "commands/tablespace.h"
  #include "executor/executor.h"
  #include "storage/buffile.h"
*** a/src/backend/utils/time/snapmgr.c
--- b/src/backend/utils/time/snapmgr.c
***************
*** 48,53 ****
--- 48,54 ----
  #include "storage/procarray.h"
  #include "utils/builtins.h"
  #include "utils/memutils.h"
+ #include "utils/resowner_private.h"
  #include "utils/snapmgr.h"
  #include "utils/tqual.h"
  
*** a/src/backend/utils/time/tqual.c
--- b/src/backend/utils/time/tqual.c
***************
*** 57,62 ****
--- 57,63 ----
  
  #include "postgres.h"
  
+ #include "access/htup.h"
  #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/transam.h"
*** a/src/include/access/genam.h
--- b/src/include/access/genam.h
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/sdir.h"
  #include "access/skey.h"
+ #include "lib/stringinfo.h"
  #include "nodes/tidbitmap.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
*** a/src/include/access/heapam.h
--- b/src/include/access/heapam.h
***************
*** 16,24 ****
  
  #include "access/sdir.h"
  #include "access/skey.h"
- #include "access/xlog.h"
  #include "nodes/primnodes.h"
  #include "storage/lock.h"
  #include "utils/relcache.h"
  #include "utils/snapshot.h"
  
--- 16,26 ----
  
  #include "access/sdir.h"
  #include "access/skey.h"
  #include "nodes/primnodes.h"
+ #include "storage/bufpage.h"
+ #include "storage/itemptr.h"
  #include "storage/lock.h"
+ #include "storage/relfilenode.h"
  #include "utils/relcache.h"
  #include "utils/snapshot.h"
  
***************
*** 125,151 **** extern void heap_restrpos(HeapScanDesc scan);
  
  extern void heap_sync(Relation relation);
  
- extern void heap_redo(XLogRecPtr lsn, XLogRecord *rptr);
- extern void heap_desc(StringInfo buf, uint8 xl_info, char *rec);
- extern void heap2_redo(XLogRecPtr lsn, XLogRecord *rptr);
- extern void heap2_desc(StringInfo buf, uint8 xl_info, char *rec);
- 
- extern XLogRecPtr log_heap_cleanup_info(RelFileNode rnode,
- 					  TransactionId latestRemovedXid);
- extern XLogRecPtr log_heap_clean(Relation reln, Buffer buffer,
- 			   OffsetNumber *redirected, int nredirected,
- 			   OffsetNumber *nowdead, int ndead,
- 			   OffsetNumber *nowunused, int nunused,
- 			   TransactionId latestRemovedXid);
- extern XLogRecPtr log_heap_freeze(Relation reln, Buffer buffer,
- 				TransactionId cutoff_xid,
- 				OffsetNumber *offsets, int offcnt);
- extern XLogRecPtr log_heap_visible(RelFileNode rnode, BlockNumber block,
- 				 Buffer vm_buffer, TransactionId cutoff_xid);
- extern XLogRecPtr log_newpage(RelFileNode *rnode, ForkNumber forkNum,
- 			BlockNumber blk, Page page);
- extern XLogRecPtr log_newpage_buffer(Buffer buffer);
- 
  /* in heap/pruneheap.c */
  extern void heap_page_prune_opt(Relation relation, Buffer buffer,
  					TransactionId OldestXmin);
--- 127,132 ----
